unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids,unit2, Menus, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    OpenDialog1: TOpenDialog;
    N5: TMenuItem;
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    BitBtn1: TBitBtn;
    N6: TMenuItem;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    N7: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure BitBtn1Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  teamnum:integer;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var i,j:integer;
    f:textfile;
    s1:string;
begin
  i:=0;
  assignfile(f,'teams.txt');
  reset(f);
  repeat
    readln(f,s1);
    i:=i+1;
  until eof(f);
  teamnum:=i;
  stringgrid1.RowCount:=i+1;
  stringgrid1.ColCount:=i+2;
  stringgrid1.FixedCols:=2;
  stringgrid1.Fixedrows:=1;
  stringgrid2.RowCount:=i+1;
  stringgrid2.ColCount:=i+3;
  stringgrid2.FixedCols:=2;
  stringgrid2.Fixedrows:=1;
  for i:=1 to teamnum do stringgrid2.cells[teamnum+2,i]:='0';
  i:=0;
  closefile(f);
  reset(f);
  repeat
    i:=i+1;
    readln(f,s1);
    stringgrid1.Cells[0,i]:=inttostr(i);
    stringgrid1.Cells[i+1,0]:=inttostr(i);
    stringgrid1.cells[1,i]:=s1;
    stringgrid1.ColWidths[i+1]:=20;
    stringgrid2.Cells[0,i]:=inttostr(i);
    stringgrid2.Cells[i+1,0]:=inttostr(i);
    stringgrid2.cells[1,i]:=s1;
    stringgrid2.ColWidths[i+1]:=20;
  until eof(f);
  closefile(f);
  for i:=2 to teamnum+1 do
    for j:=1 to teamnum do begin
      stringgrid1.Cells[i,j]:='0';
      stringgrid2.Cells[i,j]:='0';
    end;
  stringgrid1.ColWidths[0]:=20;
  stringgrid2.ColWidths[0]:=20;
  for i:=2 to teamnum do begin
    stringgrid1.ColWidths[i]:=20;
    stringgrid1.Cells[i,i-1]:='X';
    stringgrid2.ColWidths[i]:=20;
    stringgrid2.Cells[i,i-1]:='X';
  end
end;

procedure TForm1.N2Click(Sender: TObject);
var
  f:textfile;
  s1:string;
  i:integer;
begin
  opendialog1.Filter:='|*.txt| |*.*';
  i:=0;
  if opendialog1.Execute then begin
    assignfile(f,opendialog1.FileName);
    reset(f);
    repeat
      readln(f,s1);
      i:=i+1;
    until eof(f);
    teamnum:=i;
    stringgrid1.RowCount:=i+1;
    stringgrid1.ColCount:=i+2;
    stringgrid1.FixedCols:=2;
    stringgrid1.Fixedrows:=1;
    stringgrid2.RowCount:=i+1;
    stringgrid2.ColCount:=i+3;
    stringgrid2.FixedCols:=2;
    stringgrid2.Fixedrows:=1;
    for i:=1 to teamnum do stringgrid2.cells[12,i]:='0';
    i:=0;
    closefile(f);
    reset(f);
    repeat
      i:=i+1;
      readln(f,s1);
      stringgrid1.Cells[0,i]:=inttostr(i);
      stringgrid1.Cells[i+1,0]:=inttostr(i);
      stringgrid1.cells[1,i]:=s1;
      stringgrid1.ColWidths[i+1]:=20;
      stringgrid2.Cells[0,i]:=inttostr(i);
      stringgrid2.Cells[i+1,0]:=inttostr(i);
      stringgrid2.cells[1,i]:=s1;
      stringgrid2.ColWidths[i+1]:=20;
    until eof(f);
    closefile(f);
  end;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  halt;
end;

procedure TForm1.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var i:integer;
begin
  if (value='x') or (value='X') then begin
    stringgrid1.Cells[acol,arow]:='X';
    for i:=2 to 11 do
    if (acol<>i) and (stringgrid1.Cells[i,arow]='X') then begin
      stringgrid1.Cells[i,arow]:='';
    end;
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var i,j,k:integer;
begin
  for i:=1 to teamnum do
    stringgrid2.cells[teamnum+2,i]:='0';

  for i:=2 to teamnum+1 do
    for j:=1 to teamnum do begin
      stringgrid2.Cells[i,j]:='0';
    end;
  for i:=2 to teamnum+1 do
    stringgrid2.Cells[i,i-1]:='X';

  for i:=2 to teamnum+1 do
    for j:=1 to teamnum do
      if stringgrid1.Cells[i,j]<>'X' then begin
        for k:=j to teamnum do
          if stringgrid1.Cells[i,k]<>'X' then begin
            if (strtoint(stringgrid1.Cells[i,j])-strtoint(stringgrid1.Cells[i,k])>0) then begin
              stringgrid2.Cells[k+1,j]:=inttostr(strtoint(stringgrid2.Cells[k+1,j])+1);
              stringgrid2.Cells[j+1,k]:=inttostr(strtoint(stringgrid2.Cells[j+1,k])-1);
            end;
            if (strtoint(stringgrid1.Cells[i,j])-strtoint(stringgrid1.Cells[i,k])<0) then begin
              stringgrid2.Cells[k+1,j]:=inttostr(strtoint(stringgrid2.Cells[k+1,j])-1);
              stringgrid2.Cells[j+1,k]:=inttostr(strtoint(stringgrid2.Cells[j+1,k])+1);
            end;
          end;
      end;
   for i:=1 to teamnum do
     for j:=2 to teamnum+1 do begin
       if (stringgrid2.Cells[j,i]<>'X') then begin
         if strtoint(stringgrid2.Cells[j,i])>0 then
           stringgrid2.Cells[teamnum+2,i]:=inttostr(strtoint(stringgrid2.Cells[teamnum+2,i])+2);
         if strtoint(stringgrid2.Cells[j,i])=0 then
           stringgrid2.Cells[teamnum+2,i]:=inttostr(strtoint(stringgrid2.Cells[teamnum+2,i])+1);
       end;
     end;
  stringgrid2.Cells[teamnum+2,0]:=''; 
end;

procedure TForm1.N5Click(Sender: TObject);
var f:textfile;
    i,j:integer;
begin
   if savedialog1.Execute then begin
     assignfile(f,savedialog1.FileName);
     rewrite(f);
     for i:=0 to teamnum do begin
       for j:=0 to teamnum+1 do begin
         write(f,stringgrid1.cells[j,i],';');
       end;
       writeln(f);
     end;
     closefile(f);
   end;
end;

procedure TForm1.N6Click(Sender: TObject);
var f:textfile;
    s1,s2:string;
    i,j,k:integer;
begin
  opendialog1.Filter:='|*.csv| |*.*';
  if opendialog1.Execute then begin
   for i:=0 to teamnum do
     for j:=0 to teamnum+1 do stringgrid1.Cells[j,i]:='';

    assignfile(f,opendialog1.FileName);
    reset(f);
    i:=0;
    while not eof(f) do begin
      j:=0;
      s1:='';
      readln(f,s1);
      s2:='';
      for k:=1 to length(s1) do begin
        if s1[k]<>';' then
          s2:=s2+s1[k]
        else begin
          stringgrid1.Cells[j,i]:=s2;
          s2:='';
          j:=j+1;
        end;
      end;
      i:=i+1;
    end;
    closefile(f);
  end;
end;

procedure TForm1.N7Click(Sender: TObject);
var f:textfile;
    i,j:integer;
begin
   if savedialog1.Execute then begin
     assignfile(f,savedialog1.FileName);
     rewrite(f);
     for i:=0 to teamnum do begin
       for j:=0 to teamnum+2 do begin
         write(f,stringgrid2.cells[j,i],';');
       end;
       writeln(f);
     end;
     closefile(f);
   end;
end;

procedure TForm1.N4Click(Sender: TObject);
begin
  form2.Show;
end;

end.
